Bug 1163337 - Cross site state transfer - status of push gets stuck at "SENDING" after being cancelled
Summary: Cross site state transfer - status of push gets stuck at "SENDING" after bein...
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: JBoss Data Grid 6
Classification: JBoss
Component: Infinispan
Version: 6.4.0
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ER7
: 6.4.0
Assignee: Tristan Tarrant
QA Contact: Martin Gencur
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-11-12 14:22 UTC by Matej Čimbora
Modified: 2015-01-28 13:29 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: Bug


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
JBoss Issue Tracker ISPN-4975 Major New Cross site state transfer - status of push gets stuck at "SENDING" after being cancelled 2014-11-13 07:19:53 UTC

Internal Links: 1172034

Description Matej Čimbora 2014-11-12 14:22:33 UTC
Tested version: ER3, server

After invoking: site --cancelpush backupSite on the producer site, status of the push operation seems to get stuck at "SENDING" value (tested by site --pushstatus), even if state transfer is not currently in progress.
Invoking site --cancelreceive mainSite on the consumer site works correctly. New invocation of site --push backupsite leads to "X-Site state transfer to '%s' already started!" being displayed. The issue seems to be caused by XSiteStateTransferManagerImpl.siteCollector not being cleared.

Comment 2 Matej Čimbora 2014-11-13 07:19:53 UTC
Used configuration:
distributed caches, site A: 2 nodes, site B: 3 nodes, B is a backup for A.

Scenario
- Start A,B
- Take B offline using takeSiteOffline
- Load data into A
- Push state into B
- CancelPushState B
-- PushStateStatus remains stuck at SENDING & new push is not possible

Comment 4 Matej Čimbora 2014-12-04 10:45:22 UTC
The issue is fixed and push operation can be reinvoked after it had been cancelled. However, push status remains at value "CANCELLED", even if push operation is reinvoked and state transfer is currently in progress.

- Sites LON (lonCache) - main, BRN (brnCache) - backup

Consider the following scenario:   

[standalone@localhost:9999 distributed-cache=lonCache] site --push BRN
ok
[standalone@localhost:9999 distributed-cache=lonCache] site --cancelpush BRN
ok
[standalone@localhost:9999 distributed-cache=lonCache] site --pushstatus
BRN=CANCELED
[standalone@localhost:9999 distributed-cache=lonCache] site --push BRN
ok
[standalone@localhost:9999 distributed-cache=lonCache] site --pushstatus
BRN=CANCELED
[standalone@localhost:9999 distributed-cache=lonCache] site --pushstatus
BRN=OK

IMO expected behavior is:

[standalone@localhost:9999 distributed-cache=lonCache] site --push BRN
ok
[standalone@localhost:9999 distributed-cache=lonCache] site --cancelpush BRN
ok
[standalone@localhost:9999 distributed-cache=lonCache] site --pushstatus
BRN=CANCELED
[standalone@localhost:9999 distributed-cache=lonCache] site --push BRN
ok
[standalone@localhost:9999 distributed-cache=lonCache] site --pushstatus
BRN=SENDING
[standalone@localhost:9999 distributed-cache=lonCache] site --pushstatus
BRN=OK

This is obviously a bit confusing, can you please confirm this behavior is expected?

Comment 5 Matej Čimbora 2014-12-09 09:05:55 UTC
Verified, new bz will be created for aforementioned error.


Note You need to log in before you can comment on or make changes to this bug.